package xyz.mtfos.btdemo

import android.Manifest
import android.annotation.SuppressLint
import android.app.Activity
import android.content.pm.PackageManager
import android.os.Build
import android.os.Bundle
import android.os.Handler
import android.widget.Button
import android.widget.EditText
import kotlinx.android.synthetic.main.activity_main.*
import xyz.mtfos.btdemo.objectTool.bind

/**
 * Created by jay on 2017/8/9.
 */
class MainActivity : Activity() {
    val intxt: EditText by bind(R.id.intxt)
    val btn: Button by bind(R.id.bt)
    val connectBtn: Button by bind(R.id.connect)
    val disconnectBtn: Button by bind(R.id.disconnect)
    var ble: PrinterBle? = null
    val uiHandler: Handler = Handler()
    var th: Thread? = null
    var thrun: Boolean = false
    var isInit: Boolean = false

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        btn.isEnabled = false
        connectBtn.isEnabled = true
        disconnectBtn.isEnabled = false

        ble = PrinterBle(this@MainActivity, "43:43:A1:12:1F:AC", "dd535b71-8f05-4e30-beb0-6fa7ea3dfc3e", "00000001-8f05-4e30-beb0-6fa7ea3dfc3e")

        ble?.setOnStateChangeListener {
            System.out.println("Now State is >>>> " + it)
            if (it == PrinterBle.CONNECTING) {
                disconnectBtn.isEnabled = true
            }
            if (it == PrinterBle.CONNECTED) {
                btn.isEnabled = true
                connectBtn.isEnabled = false
                disconnectBtn.isEnabled = true
            }
            if (it == PrinterBle.DISCONNECTED) {
                btn.isEnabled = false
                connectBtn.isEnabled = true
                disconnectBtn.isEnabled = false
            }
        }

        ble?.setOnNotifyListener{
            System.out.println("Get Notify :::::: " + it)
        }

        var permissionCheck: Int = 0
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            permissionCheck += this@MainActivity.checkSelfPermission(android.Manifest.permission.ACCESS_COARSE_LOCATION)
            permissionCheck += this@MainActivity.checkSelfPermission(android.Manifest.permission.ACCESS_FINE_LOCATION)
            if (permissionCheck != 0) {
                requestPermissions(arrayOf(Manifest.permission.ACCESS_COARSE_LOCATION, Manifest.permission.ACCESS_FINE_LOCATION), 111)
            }
        }

        btn.setOnClickListener {
            val txt: String = intxt.text.toString()
            ble?.setAlign(PrinterBle.ALIGN_CENTER)?.addText(txt)
            ble?.sendQueue()
        }

        connectBtn.setOnClickListener {
            scanConnect()
        }
        disconnectBtn.setOnClickListener {
            disconnect()
        }
    }

    override fun onRequestPermissionsResult(requestCode: Int, permissions: Array<out String>?, grantResults: IntArray?) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults)
    }

    override fun onStop() {
        super.onStop()
        disconnect()
    }

    fun scanConnect() {
        if (ble?.init()!!) {
            ble?.startScan()
        }
    }

    fun disconnect() {
        if (ble?.mState!! == PrinterBle.SCANNING) {
            ble?.stopScan()
        }
        if (ble?.mState!! == PrinterBle.CONNECTED) {
            ble?.disconnect()
        }
    }
}